#include <functional>
#include <smmintrin.h>
#include <iostream>

int main(void) {
	typedef std::function<void(int *, int const *)> MyFun;

	MyFun test = [](int *dst, int const *src)
	{
		__m128i value = _mm_slli_epi32(_mm_lddqu_si128(reinterpret_cast<const __m128i *>(src)), 1);
		_mm_storeu_si128(reinterpret_cast<__m128i *>(dst), value);
	};

	int dst[4];
	int const src[4] = { 1, 2, 3, 4 };

	test(dst, src);

	std::cout << dst[0] << " " << dst[1] << " " << dst[2] << " " << dst[3] << std::endl;
			
	return 0;
}
